Index: trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90	(revision 3083)
@@ -1,39 +1,27 @@
-! Copyright Jérémie Burgalat (2013-2015,2017)
-! 
-! jeremie.burgalat@univ-reims.fr
-! 
-! This software is a computer program whose purpose is to provide configuration 
-! file and command line arguments parsing features to Fortran programs.
-! 
-! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
-! modify and/ or redistribute the software under the terms of the CeCILL-B
-! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
-! As a counterpart to the access to the source code and  rights to copy,
-! modify and redistribute granted by the license, users are provided only
-! with a limited warranty  and the software's author,  the holder of the
-! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
-! In this respect, the user's attention is drawn to the risks associated
-! with loading,  using,  modifying and/or developing or reproducing the
-! software by the user in light of its specific status of free software,
-! that may mean  that it is complicated to manipulate,  and  that  also
-! therefore means  that it is reserved for developers  and  experienced
-! professionals having in-depth computer knowledge. Users are therefore
-! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
-! The fact that you are presently reading this means that you have had
-! knowledge of the CeCILL-B license and that you accept its terms.
+! Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
+!
+! This file is part of SWIFT
+!
+! Permission is hereby granted, free of charge, to any person obtaining a copy of
+! this software and associated documentation files (the "Software"), to deal in
+! the Software without restriction, including without limitation the rights to
+! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+! the Software, and to permit persons to whom the Software is furnished to do so,
+! subject to the following conditions:
+!
+! The above copyright notice and this permission notice shall be included in all
+! copies or substantial portions of the Software.
+!
+! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+! FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+! COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+! IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+! CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 !! file: strings.F90
 !! summary: Strings manipulation source file
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 
 #include "defined.h"
@@ -41,11 +29,11 @@
 MODULE STRING_OP
   !! Fortran strings manipulation module
-  !! 
+  !!
   !! This module provides methods and objects to manipulate Fortran (allocatable) strings. It defines
   !! a doubly linked-list of strings, [[string_op(module):words(type)]] and several methods to format
-  !! strings or convert them in other intrinsic types. 
+  !! strings or convert them in other intrinsic types.
   USE ERRORS
   IMPLICIT NONE
-  
+
   PRIVATE
 
@@ -55,5 +43,5 @@
   ! errors module (not used but propagated)
   PUBLIC :: stdout,stderr,noerror,error, error_to_string,aborting
-  
+
   ! misc module methods
   PUBLIC :: to_string, from_string, string_is, remove_quotes, format_string,     &
@@ -86,5 +74,5 @@
   INTEGER, PUBLIC, PARAMETER :: st_integer = 4 !! Integer type ID
   INTEGER, PUBLIC, PARAMETER :: st_real    = 5 !! Real type ID
-  
+
   !> List of types names
   CHARACTER(len=*), DIMENSION(5), PARAMETER, PUBLIC :: st_type_names = &
@@ -95,5 +83,5 @@
 
 
-  
+
   INTEGER, PUBLIC, PARAMETER :: FC_BLACK     = 30 !! Black foreground csi code
   INTEGER, PUBLIC, PARAMETER :: FC_RED       = 31 !! Red foreground csi code
@@ -120,5 +108,5 @@
   INTEGER, PUBLIC, PARAMETER, DIMENSION(21) :: attributes = [FC_BLACK,     &
                                                              FC_RED,       &
-                                                             FC_GREEN,     & 
+                                                             FC_GREEN,     &
                                                              FC_YELLOW,    &
                                                              FC_BLUE,      &
@@ -133,5 +121,5 @@
                                                              BG_MAGENTA,   &
                                                              BG_CYAN,      &
-                                                             BG_WHITE,     & 
+                                                             BG_WHITE,     &
                                                              ST_NORMAL,    &
                                                              ST_BOLD,      &
@@ -139,6 +127,6 @@
                                                              ST_UNDERLINE, &
                                                              ST_BLINK      &
-                                                            ]     
-  
+                                                            ]
+
   !> Aliases for CSI codes.
   CHARACTER(len=2), DIMENSION(21), PARAMETER, PUBLIC :: csis =(/ &
@@ -151,9 +139,9 @@
     MODULE PROCEDURE ws_affect
   END INTERFACE
-  
+
   !> Clear either a scalar or a vector of list of [[words(type)]]
   !!
-  !! The interface encapsulates words _destructors_, that deallocate memory used 
-  !! by the given list(s) of words. This method should be called anytime words 
+  !! The interface encapsulates words _destructors_, that deallocate memory used
+  !! by the given list(s) of words. This method should be called anytime words
   !! object(s) is no longer used to avoid memory leaks.
   !! @note
@@ -168,8 +156,8 @@
   !! The interface encapsulates two subroutines:
   !!
-  !! - [[ws_extend_ws(subroutine)]](this,other) which extends __this__ by __other__ 
+  !! - [[ws_extend_ws(subroutine)]](this,other) which extends __this__ by __other__
   !!   (both are words objects).
   !! - [[ws_extend_str(subroutine)]](this,str,delimiter,merge) which splits __str__
-  !!   according to __delimiter__ (and optionally __merge__) and then extends 
+  !!   according to __delimiter__ (and optionally __merge__) and then extends
   !!   __this__ with the resulting tokens.
   INTERFACE words_extend
@@ -192,5 +180,5 @@
   !!   parenthesis can be omitted.
   !! - __str__ is an allocatable string with the converted value in output, or an empty
-  !!   string if the conversion failed. 
+  !!   string if the conversion failed.
   INTERFACE to_string
     MODULE PROCEDURE int2str_as,int2str_fs
@@ -201,9 +189,9 @@
     MODULE PROCEDURE dcplx2str_as,dcplx2str_fs
   END INTERFACE
-  
+
   !> Convert a string into an intrisinc type
   !!
   !! All methods defined in the interface are functions which take in arguments,
-  !! a string (input) and an output variable with the relevant type (or vectors of both). 
+  !! a string (input) and an output variable with the relevant type (or vectors of both).
   !! They always return an error object which is set to -5 error code (i.e. cannot cast value)
   !! on error, otherwise [[errors(module):noerror(variable)]].
@@ -217,5 +205,5 @@
   !! The generic interface adds CSI codes to the given value and returns a fortran intrinsic string.
   !!
-  !! This is convinient wrapper to [[string_op(module):to_string(interface)]] and 
+  !! This is convinient wrapper to [[string_op(module):to_string(interface)]] and
   !! [[string_op(module):add_csi(function)]].
   !!
@@ -251,10 +239,10 @@
   !! It's part of the doubly linked list words.
   TYPE, PUBLIC :: word
-#if HAVE_FTNDTSTR    
+#if HAVE_FTNDTSTR
     CHARACTER(len=:), ALLOCATABLE :: value !! Value of the word
-#else    
+#else
     !> Value of the word
     !!
-    !! @warning 
+    !! @warning
     !! It is always limited to [[string_op(module):st_slen(variable)]] characters.
     CHARACTER(len=st_slen)        :: value = ''
@@ -263,5 +251,5 @@
     TYPE(word), PRIVATE, POINTER  :: prev => null() !! Previous word in the list of words
   END TYPE word
-  
+
   !> Define a list of words
   TYPE, PUBLIC :: words
@@ -270,5 +258,5 @@
     TYPE(word), PRIVATE, POINTER :: tail => null() !! Last word in the list
     TYPE(word), PRIVATE, POINTER :: iter => null() !! Current word (iterator)
-#if HAVE_FTNPROC 
+#if HAVE_FTNPROC
     CONTAINS
     PROCEDURE, PRIVATE :: ws_extend_ws
@@ -279,7 +267,7 @@
       !! Insert a word at given index
     PROCEDURE, PUBLIC :: append      => words_append
-      !! Append a word at the end of the list 
+      !! Append a word at the end of the list
     PROCEDURE, PUBLIC :: prepend     => words_prepend
-      !! Prepend a word at the beginning of the list 
+      !! Prepend a word at the beginning of the list
     PROCEDURE, PUBLIC :: get         => words_get
       !! Get the word at given index
@@ -293,5 +281,5 @@
       !! Reverse the list in place
     PROCEDURE, PUBLIC :: reversed    => words_reversed
-      !! Get a reversed copy of the list 
+      !! Get a reversed copy of the list
     PROCEDURE, PUBLIC :: dump        => words_dump
       !! Dump words of the list (on per line)
@@ -301,5 +289,5 @@
       !! Convert the list in a vector
     PROCEDURE, PUBLIC :: pop         => words_pop
-      !! Pop a word from the list and returns it 
+      !! Pop a word from the list and returns it
     PROCEDURE, PUBLIC :: remove      => words_remove
       !! Remove a word from the list
@@ -318,7 +306,7 @@
 #endif
   END TYPE words
-  
+
   CONTAINS
-  
+
   FUNCTION word_length(this) RESULT(lgth)
     !! Get the trimmed length of the word object
@@ -327,19 +315,19 @@
     INTEGER :: lgth
       !! The length of the word's value (without trailing spaces)
-#if HAVE_FTNDTSTR    
+#if HAVE_FTNDTSTR
     IF (.NOT.ALLOCATED(this%value)) THEN
       lgth = 0 ; RETURN
     ENDIF
-#endif    
+#endif
     lgth = LEN_TRIM(this%value)
     RETURN
   END FUNCTION word_length
-  
+
   SUBROUTINE disconnect_word(this)
     !! Disconnect a word object
     !!
     !! The object is no more connected to its neighbours which are connected together.
-    !! @note 
-    !! After this method is called the object is no longer connected to its parent words 
+    !! @note
+    !! After this method is called the object is no longer connected to its parent words
     !! object and should be deallocated in order to avoid memory leaks.
     TYPE(word), INTENT(inout) :: this
@@ -351,5 +339,5 @@
     RETURN
   END SUBROUTINE disconnect_word
-  
+
   SUBROUTINE ws_affect(this,other)
     !! words object assignment operator subroutine
@@ -365,5 +353,5 @@
       cur => other%head
       DO WHILE(associated(cur))
-#if HAVE_FTNDTSTR      
+#if HAVE_FTNDTSTR
         IF (.NOT.ALLOCATED(cur%value)) THEN
           CALL words_append(this,"")
@@ -380,14 +368,14 @@
     RETURN
   END SUBROUTINE ws_affect
-  
+
   SUBROUTINE ini_word(this,value)
     !! Initialize the first word of a list of words
     !!
-    !! This subroutine is not a constructor. It is only intended to set the first word 
+    !! This subroutine is not a constructor. It is only intended to set the first word
     !! object in a words object.
     TYPE(words), INTENT(inout)   :: this
       !! A words object reference
     CHARACTER(len=*), INTENT(in) :: value
-      !! A string with the word used to initialize the list 
+      !! A string with the word used to initialize the list
     ALLOCATE(this%head)
     this%tail => this%head
@@ -401,6 +389,6 @@
     !!
     !! This subroutine deallocates all memory used by the given words object.
-    !! @warning 
-    !! The subroutine should be called whenever a words is no more used (e.g. at 
+    !! @warning
+    !! The subroutine should be called whenever a words is no more used (e.g. at
     !! the end of the current scope), otherwise memory leaks could occur.
     TYPE(words),INTENT(inout), TARGET :: obj
@@ -408,5 +396,5 @@
     TYPE(word), POINTER :: cur,next
     IF (obj%nw == 0) RETURN
-    cur => obj%head 
+    cur => obj%head
     DO WHILE(ASSOCIATED(cur))
       next => cur%next
@@ -426,6 +414,6 @@
     !!
     !! This subroutine deallocates all memory used by the given vector of words objects.
-    !! @warning 
-    !! The subroutine should be called whenever a words is no more used (e.g. at the end 
+    !! @warning
+    !! The subroutine should be called whenever a words is no more used (e.g. at the end
     !! of the current scope), otherwise memory leaks could occur.
     TYPE(words),INTENT(inout), DIMENSION(:) :: objs
@@ -453,12 +441,12 @@
   END SUBROUTINE ws_extend_ws
 
-  SUBROUTINE ws_extend_str(this,str,delimiter,merge,protect) 
+  SUBROUTINE ws_extend_str(this,str,delimiter,merge,protect)
     !> Extend a list of word with a given string
-    !! @details The method adds a new list of words to the current list by 
+    !! @details The method adds a new list of words to the current list by
     !! splitting a string using a set of delimiters.
-    !! 
+    !!
     !!   - If __delimiter__ is not given, THEN blank space is used.
-    !!   - __delimiter__ can be a string of any length, but each character of 
-    !!     the sequence is seen as a single delimiter. Each time one of these 
+    !!   - __delimiter__ can be a string of any length, but each character of
+    !!     the sequence is seen as a single delimiter. Each time one of these
     !!     special character is seen on the string, it is splitted.
     !!   - If __protect__ is set to .true. THEN delimiter enclosed by
@@ -466,5 +454,5 @@
     !!   - The optional argument __merge__ instructs the method wether to merge
     !!     or not successive delimiters in the string.
-    !! 
+    !!
     !! For example, considering the following string:
     !! <center>@verbatim "I like coffee and bananas." @endverbatim</center>
@@ -484,10 +472,10 @@
       !! A string to split in words
     CHARACTER(len=*), INTENT(in), OPTIONAL :: delimiter
-      !! An optional string with the words delimiters (default to blank space). 
+      !! An optional string with the words delimiters (default to blank space).
     LOGICAL, INTENT(in), OPTIONAL          :: merge
       !! An optional boolean control flag that instructs the method
       !! wether to merge or not successive delimiters (default to .false.)
     LOGICAL, INTENT(in), OPTIONAL          :: protect
-      !! An optional boolean flag with .true. to indicate that 
+      !! An optional boolean flag with .true. to indicate that
       !! delimiter characters between quotes are protected
     ! - LOCAL
@@ -498,5 +486,5 @@
     CHARACTER(len=1), PARAMETER   :: sq = CHAR(39) ! single quote ascii code
     CHARACTER(len=1), PARAMETER   :: dq = CHAR(34) ! double quotes ascii code
-    stat=0 ; p=1 ; indq = .false. ; insq = .false. 
+    stat=0 ; p=1 ; indq = .false. ; insq = .false.
     seps = ' '
     zmerge = .false. ; IF (PRESENT(merge)) zmerge = merge
@@ -506,12 +494,12 @@
     ENDIF
     sl = LEN(str) ; IF (sl == 0) RETURN
-    outer =     (INDEX(str,sq) == 1 .AND. INDEX(str,sq,.true.) == LEN(str)) & 
+    outer =     (INDEX(str,sq) == 1 .AND. INDEX(str,sq,.true.) == LEN(str)) &
             .OR.(INDEX(str,dq) == 1 .AND. INDEX(str,dq,.true.) == LEN(str))
     ! no delimiter found or (have outer quotes and should protect)
     IF (SCAN(str,seps) == 0.OR.(outer.AND.zprotect)) THEN
-      CALL words_append(this,remove_quotes(str)) 
+      CALL words_append(this,remove_quotes(str))
       RETURN
     ENDIF
-    ! We have to loop... 
+    ! We have to loop...
     i = 1 ; curw=''
     DO
@@ -564,8 +552,8 @@
     !! Get the pointer of the word object at given index
     !!
-    !! The method returns the pointer of the word object at the given index. 
+    !! The method returns the pointer of the word object at the given index.
     !! If index is out of range a null poitner is returned.
     OBJECT(words), INTENT(in) :: this
-      !! A words object 
+      !! A words object
     INTEGER, INTENT(in)       :: idx
       !! An integer with the index of the desired object in __this__
@@ -629,8 +617,8 @@
     ELSE
       IF (idx > (this%nw+1)/2) THEN
-        nx => this%tail 
+        nx => this%tail
         DO i=1, this%nw - idx ; nx => nx%prev ; ENDDO
       ELSE
-        nx => this%head 
+        nx => this%head
         DO i=1, idx-1 ; nx => nx%next ; ENDDO
       ENDIF
@@ -647,8 +635,8 @@
   SUBROUTINE words_append(this,value)
     !! Append a word to the list of word
-    !! 
-    !! The method appends a word to the list of word. This is a convinient wrapper to 
+    !!
+    !! The method appends a word to the list of word. This is a convinient wrapper to
     !! [[string_op(module)::words_insert(subroutine)]] to add a new word at the beginning of the list.
-    OBJECT(words), INTENT(inout) :: this  !! A words object 
+    OBJECT(words), INTENT(inout) :: this  !! A words object
     CHARACTER(len=*), INTENT(in) :: value !! A string to append
     !CALL words_insert(this,this%nw+1,value)
@@ -668,5 +656,5 @@
     !this%tail%value = TRIM(value)
     !this%tail%prev => np
-    !this%tail%prev%next => this%tail 
+    !this%tail%prev%next => this%tail
     RETURN
   END SUBROUTINE words_append
@@ -677,5 +665,5 @@
     !! The method prepends a word to the list of word. This is a convinient wrapper to
     !! [[string_op(module)::words_insert(subroutine)]] to add a new word at the end of the list.
-    OBJECT(words), INTENT(inout) :: this  !! A words object 
+    OBJECT(words), INTENT(inout) :: this  !! A words object
     CHARACTER(len=*), INTENT(in) :: value !! A string to prepend
     CALL words_insert(this,0,value)
@@ -685,8 +673,8 @@
   FUNCTION words_get(this,idx,case) RESULT (res)
     !! Get the word's value at given index
-    !! 
+    !!
     !! The method attempts to get the word's value at the given index. If index is out of range
     !! an empty string is returned.
-    !! @note 
+    !! @note
     !! The returned string is always trimmed.
     OBJECT(words), INTENT(in)              :: this
@@ -694,5 +682,5 @@
     INTEGER, INTENT(in)                    :: idx
       !! An integer with the index of a word in the list
-    CHARACTER(len=5), INTENT(in), OPTIONAL :: case 
+    CHARACTER(len=5), INTENT(in), OPTIONAL :: case
       !! An optional string with either 'upper' or 'lower' to get the value converted in the relevant case
     CHARACTER(len=:), ALLOCATABLE :: res
@@ -704,5 +692,5 @@
     ENDIF
     IF (PRESENT(case)) THEN
-      IF (case == "upper") res = to_upper(cur%value) 
+      IF (case == "upper") res = to_upper(cur%value)
       IF (case == "lower") res = to_lower(cur%value)
     ELSE
@@ -729,5 +717,5 @@
     !!
     !! The method computes and returns the longest (trimmed) word's width in the words object.
-    OBJECT(words), INTENT(in) :: this !! A words object 
+    OBJECT(words), INTENT(in) :: this !! A words object
     INTEGER :: res                    !! An integer with the maximum width (0 if the list is empty)
     TYPE(word), POINTER :: cur
@@ -744,11 +732,11 @@
   FUNCTION words_get_total_width(this) RESULT(width)
     !! Get the total width of all words stored in the list of words
-    !! 
-    !! The method computes and returns the total width of all words stored in 
+    !!
+    !! The method computes and returns the total width of all words stored in
     !! the list of words.
-    !! @note 
+    !! @note
     !! Total width is computed using strings::word_length so it only takes
     !! into account trimmed words (without trailing blanks)
-    !! @note 
+    !! @note
     !! If csi codes have been added to words elements they are counted in the width.
     OBJECT(words), INTENT(in) :: this !! A words object
@@ -795,5 +783,5 @@
     DO WHILE(ASSOCIATED(cur))
       CALL words_append(res,cur%value)
-      IF (ASSOCIATED(cur,this%iter)) res%iter => res%tail 
+      IF (ASSOCIATED(cur,this%iter)) res%iter => res%tail
       cur => cur%prev
     ENDDO
@@ -804,10 +792,10 @@
   SUBROUTINE words_dump(this,lun)
     !! Dump the list of words
-    !! 
+    !!
     !! The method dumps on the given logical unit the elements of the list one by line.
     OBJECT(words), INTENT(in)     :: this
       !! A words object to dump
     INTEGER, INTENT(in), OPTIONAL :: lun
-      !! An optional integer with the printing logical unit. If not given, the list is dumped on 
+      !! An optional integer with the printing logical unit. If not given, the list is dumped on
       !! standard output stream.
     TYPE(word), POINTER :: cur
@@ -834,5 +822,5 @@
     !! setting it back as values of the list of words.
     OBJECT(words), INTENT(in)              :: this
-      !! A words object 
+      !! A words object
     CHARACTER(len=*), INTENT(in), OPTIONAL :: delimiter
       !! An optional string used as delimiter between each words
@@ -867,5 +855,5 @@
     !! .false., otherwise it returns .true.
     !! @note
-    !! If elements in __this__ words object are wider than [[string_op(module):st_slen(variable)]], output 
+    !! If elements in __this__ words object are wider than [[string_op(module):st_slen(variable)]], output
     !! values will be truncated.
     OBJECT(words), INTENT(in)                                      :: this
@@ -895,5 +883,5 @@
     !! Pop a word in the list of words
     !!
-    !! The method removes the word of the list at given index and returns it. If no index is given, 
+    !! The method removes the word of the list at given index and returns it. If no index is given,
     !! last word of the list is removed.
     !!
@@ -906,8 +894,8 @@
     INTEGER, INTENT(in), OPTIONAL :: idx
       !! Optional index of the word to delete
-    LOGICAL, INTENT(in), OPTIONAL :: move_forward 
-      !! Move the iterator forward if needed. By default the iterator is moved backward. 
+    LOGICAL, INTENT(in), OPTIONAL :: move_forward
+      !! Move the iterator forward if needed. By default the iterator is moved backward.
     CHARACTER(len=:), ALLOCATABLE :: value
-      !! The word's value at given index 
+      !! The word's value at given index
     LOGICAL             :: zforward
     INTEGER             :: zidx
@@ -935,5 +923,5 @@
     !! Remove the word of the list at given index
     !!
-    !! The method removes the word of the list at given index. If no index is given, last word 
+    !! The method removes the word of the list at given index. If no index is given, last word
     !! of the list is removed.
     !!
@@ -947,6 +935,6 @@
       !! Index of the word to delete
     LOGICAL, INTENT(in), OPTIONAL :: move_forward
-      !! Move the iterator forward if needed. By default the iterator is moved backward. 
-    LOGICAL             :: zforward 
+      !! Move the iterator forward if needed. By default the iterator is moved backward.
+    LOGICAL             :: zforward
     INTEGER             :: zidx
     TYPE(word), POINTER :: cur
@@ -982,5 +970,5 @@
 
   FUNCTION words_valid(this) RESULT(ret)
-    !! Check if the current iterated word is valid 
+    !! Check if the current iterated word is valid
     OBJECT(words), INTENT(in) :: this !! A words object
     LOGICAL :: ret                    !! A logical flag with .true. if the current iterated word is valid
@@ -993,5 +981,5 @@
       !! A words object
     CHARACTER(len=:), ALLOCATABLE :: wrd
-      !! A string with the value of the current word or __an unallocated string__ if current word 
+      !! A string with the value of the current word or __an unallocated string__ if current word
       !! is not valid (see [[string_op(module):words_valid(function)]]).
     IF (ASSOCIATED(this%iter)) THEN
@@ -1001,9 +989,9 @@
 
   SUBROUTINE words_reset(this,to_end)
-    !! Reset the iterator 
-    !!
-    !! The method resets the iterator either at the beginning or at the end of the list of words 
+    !! Reset the iterator
+    !!
+    !! The method resets the iterator either at the beginning or at the end of the list of words
     !! (if __to_end__ is set to .true.).
-    OBJECT(words), INTENT(inout)  :: this   !! A words object 
+    OBJECT(words), INTENT(inout)  :: this   !! A words object
     LOGICAL, INTENT(in), OPTIONAL :: to_end !! An optional logical flag with .true. to reset the iterator at the end of the list
     this%iter => this%head
@@ -1018,17 +1006,17 @@
   FUNCTION tokenize(str,vector,delimiter,merge,protect) RESULT(ok)
     !! Tokenize a string.
-    CHARACTER(len=*), INTENT(in)                             :: str
+    CHARACTER(len=*), INTENT(in)                                   :: str
       !! A string to tokenize
-    CHARACTER(len=*), INTENT(out), DIMENSION(:), ALLOCATABLE :: vector
-      !! An allocatable vector of strings with the tokens found. If string cannot be tokenized, 
+    CHARACTER(len=st_slen), INTENT(out), DIMENSION(:), ALLOCATABLE :: vector
+      !! An allocatable vector of strings with the tokens found. If string cannot be tokenized,
       !! the vector is __allocated to 0 elements__ and the method returns .false..
-    CHARACTER(len=*), INTENT(in), OPTIONAL                   :: delimiter
-      !! An optional string with the words delimiters. It is set to blank space by default. 
+    CHARACTER(len=*), INTENT(in), OPTIONAL                         :: delimiter
+      !! An optional string with the words delimiters. It is set to blank space by default.
       !! Note that each character is seen as a single delimiter.
-    LOGICAL, INTENT(in), OPTIONAL                            :: merge
-      !! An optional boolean control flag with .true. that instructs the method whether to 
+    LOGICAL, INTENT(in), OPTIONAL                                  :: merge
+      !! An optional boolean control flag with .true. that instructs the method whether to
       !! merge or not successive delimiters. Default to .false.
-    LOGICAL, INTENT(in), OPTIONAL                            :: protect
-      !! An optional boolean flag with .true. to indicate that delimiter characters between 
+    LOGICAL, INTENT(in), OPTIONAL                                  :: protect
+      !! An optional boolean flag with .true. to indicate that delimiter characters between
       !! quotes are protected. Default to .true.
     LOGICAL :: ok
@@ -1040,5 +1028,5 @@
     integer                       :: i,nw
     ok = .true.
-    zmerge = .false. ; zprotect = .true. ; seps = ' ' 
+    zmerge = .false. ; zprotect = .true. ; seps = ' '
     IF (PRESENT(merge)) zmerge = merge
     IF (PRESENT(protect)) zprotect = protect
@@ -1073,5 +1061,5 @@
     !! The output string is trimmed from leading and trailing blank spaces (after quotes removal !)
     CHARACTER(len=*), INTENT(in)  :: str  !! A string to check
-    CHARACTER(len=:), ALLOCATABLE :: ostr !! A string without external quotes (if any).  
+    CHARACTER(len=:), ALLOCATABLE :: ostr !! A string without external quotes (if any).
     CHARACTER(len=1), PARAMETER   :: sq=CHAR(39), dq=CHAR(34)
     CHARACTER(len=2), PARAMETER   :: dsq=CHAR(39)//CHAR(34)
@@ -1090,9 +1078,9 @@
     !! Check if string represents an intrinsic type
     !!
-    !! The method checks if the given string represents an intrinsic type. Both logical and complex type 
+    !! The method checks if the given string represents an intrinsic type. Both logical and complex type
     !! are checked in a strict way :
     !!
     !! - A string is a logical if it is one of the following value: __.false.__, __.true.__, __F__, __T__.
-    !! - A string is potentially a complex if it has the following format: __(\*\*\*,\*\*\*)__ where 
+    !! - A string is potentially a complex if it has the following format: __(\*\*\*,\*\*\*)__ where
     !!   __\*\*\*__ is checked to see wether it is numerical or not.
     !!
@@ -1102,8 +1090,8 @@
     !!   [0-9]*.?[0-9]*?([ed][+-]?[0-9]+)?
     !! ```
-    !! Obviously if returned value is greater than 3, the string can be converted in 
+    !! Obviously if returned value is greater than 3, the string can be converted in
     !! floating point value.
     !!
-    !! Empty input string is simply considered to be of string type !  
+    !! Empty input string is simply considered to be of string type !
     CHARACTER(len=*), INTENT(in) :: str
       !! A string to check
@@ -1213,22 +1201,22 @@
       ALLOCATE(output,source='') ; RETURN
     ENDIF
-    i=0 ; IF (PRESENT(idt1)) i = MAX(i,idt1) 
-    ALLOCATE(CHARACTER(len=i) :: output) 
-    IF (i > 0) output(1:i) = CHAR(32) 
+    i=0 ; IF (PRESENT(idt1)) i = MAX(i,idt1)
+    ALLOCATE(CHARACTER(len=i) :: output)
+    IF (i > 0) output(1:i) = CHAR(32)
     ! i0 is relative to i1 and must be >= 0
     IF (PRESENT(idto)) i = MAX(i+idto,0)
     ALLOCATE(CHARACTER(len=i+1) :: idts)
-    idts(1:1) = NEW_LINE('A') ; IF (i>1) idts(2:) = CHAR(32) 
-    ! Builds output string 
+    idts(1:1) = NEW_LINE('A') ; IF (i>1) idts(2:) = CHAR(32)
+    ! Builds output string
     c=1 ; mx = LEN_TRIM(str)
     i = INDEX(str(c:),'\n') ; ti = c+i-1
     IF (i == 0) THEN
-      output=output//TRIM(str(ti+1:mx)) 
+      output=output//TRIM(str(ti+1:mx))
     ELSE
-      output=output//TRIM(str(c:ti-1)) ; c=ti+2 
+      output=output//TRIM(str(c:ti-1)) ; c=ti+2
       DO
         i = INDEX(str(c:),"\n") ; ti = c+i-1
         IF (i == 0) THEN
-          output=output//TRIM(str(ti+1:mx)) ; c = mx+1 
+          output=output//TRIM(str(ti+1:mx)) ; c = mx+1
         ELSE
           output=output//idts//str(c:ti-1) ; c = ti+2
@@ -1243,11 +1231,11 @@
 
   FUNCTION format_paragraph(str,width,idt1,idto) RESULT(output)
-    !! Split and format a string over several lines 
-    !! 
-    !! The function splits an input string in words so output lines fit (almost) in __width__ characters. 
-    !! The method handles indentation level (defined as leading blank spaces). It also accounts for known 
+    !! Split and format a string over several lines
+    !!
+    !! The function splits an input string in words so output lines fit (almost) in __width__ characters.
+    !! The method handles indentation level (defined as leading blank spaces). It also accounts for known
     !! csi (see [[string_op(module):attributes(variable)]]).
     !! @note
-    !! Words are considered indivisible and thus output lines can sometimes exceed the maximum width if 
+    !! Words are considered indivisible and thus output lines can sometimes exceed the maximum width if
     !! there is not enough space to put a word (with the associated indentation if given). The default
     !! behavior in that case is to print the word in a new line (with the correct leading blank spaces).
@@ -1256,5 +1244,5 @@
     !! method still computes the paragraph, but each words will be set on a new line with the appropriate
     !! indentation.
-    CHARACTER(len=*), INTENT(in)  :: str    !! string with the content to split 
+    CHARACTER(len=*), INTENT(in)  :: str    !! string with the content to split
     INTEGER, INTENT(in)           :: width  !! An positive integer with the maximum width of a line
     INTEGER, INTENT(in), OPTIONAL :: idt1   !! An optional integer with the indentation level of the first output line
